/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sk.upjs.ics.kniznica;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author student
 */
public class PamatovaKniznica implements Kniznica {
    private List<Kniha> zoznamKnih = new ArrayList<Kniha>();
    
    private List<Kniha> pozicaneKnihy = new ArrayList<Kniha>();

    public PamatovaKniznica() {
        Kniha pumpa = new Kniha();
        pumpa.setAutor("Jan Shell");
        pumpa.setIsbn(12345);
        pumpa.setNazov("O zlavach na pumpe");
        pumpa.setZaner("letak na zlavy");

        Kniha ajJaTeba = new Kniha();
        ajJaTeba.setAutor("Maxim E. Matkin");
        ajJaTeba.setIsbn(9875);
        ajJaTeba.setNazov("Aj ja teba");
        ajJaTeba.setZaner("slovensky moderny roman");

        zaeviduj(pumpa);
        zaeviduj(ajJaTeba);
            
    }



    public void zaeviduj(Kniha kniha) {
        zoznamKnih.add(kniha);
    }

    public void vyrad(Kniha kniha) {
        zoznamKnih.remove(kniha);
    }

    public boolean pozicaj(Kniha kniha) {
        if(jeVEvidencii(kniha) && jeVolna(kniha)){
            pozicaneKnihy.add(kniha);
            return true;
        }
        return false;
    }

    public boolean jeVEvidencii(Kniha kniha) {
        return zoznamKnih.contains(kniha);
    }

    public boolean jePozicana(Kniha kniha) {
        return pozicaneKnihy.contains(kniha);
    }

    public boolean jeVolna(Kniha kniha) {
        return !jePozicana(kniha);
    }
    
    

    public void vrat(Kniha kniha) {
        pozicaneKnihy.remove(kniha);
    }

    public List<Kniha> vyhladajPodlaAutora(String autor) {
        List<Kniha> najdeneKnihy = new ArrayList<Kniha>();
        for(Kniha kniha : zoznamKnih){
            if(kniha.getAutor().equals(autor)) najdeneKnihy.add(kniha);
        }
        return najdeneKnihy;
    }

    public List<Kniha> vyhladajPodlaNazvu(String nazov) {
        List<Kniha> najdeneKnihy = new ArrayList<Kniha>();
        for(Kniha kniha : zoznamKnih){
            if(kniha.getNazov().equals(nazov)) najdeneKnihy.add(kniha);
        }
        return najdeneKnihy;
    }

    public Kniha vyhladajPodlaIsbn(long isbn) {
        for(Kniha kniha : zoznamKnih){
            if(kniha.getIsbn() == isbn) return kniha;
        }
        return null;
    }

    public int getPocetKnih() {
        return zoznamKnih.size();
    }

    public List<Kniha> getVsetkyKnihy() {
        return new ArrayList<Kniha>(zoznamKnih);
    }
    
}
