package sk.upjs.ics.kniznica;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

public class SuborovaKniznica implements Kniznica {

    private Kniznica kniznicaDelegat = new PamatovaKniznica();

    private File subor;

    public SuborovaKniznica(File data) throws FileNotFoundException {
        Scanner scanner = null;
        try {
            scanner = new Scanner(data);
            this.subor = data;

            while (scanner.hasNextLine()) {
                String riadok = scanner.nextLine();
                String[] zlozky = riadok.split(";");

                Kniha kniha = new Kniha();
                kniha.setAutor(zlozky[0]);
                kniha.setNazov(zlozky[1]);

                kniznicaDelegat.zaeviduj(kniha);
            }
        } finally {
            if(scanner != null) {
                scanner.close();
            }
        }
    }

    public void zaeviduj(Kniha kniha) {
        kniznicaDelegat.zaeviduj(kniha);
        PrintWriter pwSubor = null;
        try {
             pwSubor = new PrintWriter(new FileWriter(subor, true));
             pwSubor.println(kniha.getAutor() + ";" + kniha.getNazov());
        } catch (IOException ex) {
            System.err.println("Nastala I/O chyba pri evidencii knihy.");
            ex.printStackTrace();
        } finally {
            if(pwSubor != null) {
                pwSubor.close();
            }
        }

    }

    public void vyrad(Kniha kniha) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public boolean pozicaj(Kniha kniha) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void vrat(Kniha kniha) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public List<Kniha> vyhladajPodlaAutora(String autor) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public List<Kniha> vyhladajPodlaNazvu(String nazov) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Kniha vyhladajPodlaIsbn(long isbn) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public boolean jePozicana(Kniha kniha) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public boolean jeVolna(Kniha kniha) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public boolean jeVEvidencii(Kniha kniha) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public int getPocetKnih() {
        return kniznicaDelegat.getPocetKnih();
    }

    public List<Kniha> getVsetkyKnihy() {
        return kniznicaDelegat.getVsetkyKnihy();
    }
}
