package sk.upjs.ics.kniznica.db;

import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Date;
import java.util.UUID;
import org.hsqldb.jdbc.JDBCDriver;
import sk.upjs.ics.kniznica.Kniha;

public class Databaza {
    static {
        new JDBCDriver();
    }

    public void vytvorTabulky() {
        String sql = "CREATE TABLE kniha ("
                    + "ID VARCHAR(200) NOT NULL PRIMARY KEY,"
                    + "autor VARCHAR(200),"
                    + "nazov VARCHAR(200))";
        vykonajInsertAleboUpdate(sql);
    }

    private void vykonajInsertAleboUpdate(String sql) {
        System.out.println(sql);

        Connection con = null;
        Statement prikaz = null;
        try {
            con = DriverManager.getConnection("jdbc:hsqldb:hsql://localhost/xdb", "SA", "");
            prikaz = con.createStatement();

            prikaz.executeUpdate(sql);
        } catch (SQLException e) {
            e.printStackTrace();
        } finally {
            try {
                if(prikaz != null) {
                    prikaz.close();
                }
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if(con != null) {
                    con.close();
                }
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }
    }

    public void zatvor() {
        vykonajInsertAleboUpdate("SHUTDOWN");
    }

    public void vlozData(Kniha kniha) {
        vykonajInsertAleboUpdate("INSERT INTO KNIHA VALUES ("
                + "'" + UUID.randomUUID().toString() + "'"                
                + ", '" + kniha.getAutor() + "'"
                + ", '" + kniha.getNazov() + "'"
                + ")");
    }

    public static void main(String[] args) {
        Databaza db = new Databaza();
        //db.vytvorTabulky();
        
        Kniha k = new Kniha();
        k.setAutor("J. K. Rowling");
        k.setNazov("HP 7");
        db.vlozData(k);

        db.zatvor();
    }
}
