package sk.upjs.ics.kniznica.gui;

import java.util.Arrays;
import java.util.List;
import javax.swing.table.AbstractTableModel;
import sk.upjs.ics.kniznica.DaoFactory;
import sk.upjs.ics.kniznica.Kniha;
import sk.upjs.ics.kniznica.Kniznica;

public class KniznicaTableModel extends AbstractTableModel{
    public static final List<String> NAZVY_STLPCOV = Arrays.asList("Autor", "Názov", "ISBN", "Žáner");

    private Kniznica kniznica = DaoFactory.getKniznica();

    public int getRowCount() {
        return kniznica.getPocetKnih();
    }

    public int getColumnCount() {
        return 4;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        Kniha kniha = kniznica.getVsetkyKnihy().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return kniha.getAutor();
            case 1:
                return kniha.getNazov();
            case 2:
                return kniha.getIsbn();
            case 3:
                return kniha.getZaner();
            default:
                return null;
        }
    }

    @Override
    public String getColumnName(int column) {
        return NAZVY_STLPCOV.get(column);
    }



    
}
